
/****** Object:  StoredProcedure [dbo].[DSS_POS_Ventas]    Script Date: 07/05/2013 13:18:44 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO


ALTER PROCEDURE [dbo].[DSS_POS_Ventas]
				( @Modo         INT,
				  @FecIni       DATE,
				  @FecFin       DATE,
				  @id_pvta      INT,
				  @id_fami      INT,
				  @CantArti     INT,
				  @MasVendidos  BIT)
AS
BEGIN 

	DECLARE @EnlaceFront BIT = 1
	DECLARE @EnlaceAcc   BIT = 0
	DECLARE @vSql VARCHAR(5000) = ''
	
	DECLARE @vPOS VARCHAR(100) = 'Todos'
	
	IF @id_pvta > 0
	BEGIN
		SET @vPOS = (SELECT LTRIM(RTRIM(cod_pvta)) + ' - ' + desc_pvta 
		                FROM RESTPVTA 
		                WHERE id_pvta = @id_pvta)
	END
	
	DECLARE @vFamilia VARCHAR(100) = 'Todos'
	
	IF @id_fami > 0
	BEGIN
		SET @vFamilia = (SELECT Desc_fami FROM RESTFAMI WHERE id_fami = @id_fami)
	END
	
	DECLARE @vCantArti VARCHAR(50) = 'No aplica'
	
	IF @Modo = 2 
	BEGIN
		SET @vCantArti = 'Todos'
	END
	
	IF @Modo = 2 AND @CantArti > 0
	BEGIN
		SET @vCantArti = CONVERT(VARCHAR(50), @CantArti)
	END
	
	DECLARE @vMasVendidos VARCHAR(50) = 'No aplica'
	
	IF @Modo = 2 
	BEGIN
		SET @vMasVendidos = 'Ms Vendidos'
	END
	
	IF @Modo = 2 AND @MasVendidos = 0
	BEGIN
		SET @vMasVendidos = 'Menos Vendidos'
	END


	CREATE TABLE #Ventas
	(   Credito   VARCHAR(255),
		id_mone   INT,            id_pvta   INT,            cod_pvta    CHAR(5),        desc_pvta    CHAR(25), 
		id_fami   INT,            desc_fami CHAR(25),
		id_arti   INT,            cod_arti  VARCHAR(11),    desc_arti   VARCHAR(60),    cod_mone     CHAR(3),
		desc_mone CHAR(18),       cantidad  NUMERIC(21, 2), id_cta_con1 INT,            conc_ingreso CHAR(30),
		tasa_inv  NUMERIC(21, 2), vbrutas   NUMERIC(21, 2),
		vnetas    NUMERIC(21, 2), dcto      NUMERIC(21, 2), recargo     NUMERIC(21, 2), vcosto       NUMERIC(21, 2),
		impu_vent NUMERIC(21, 2), impu_serv NUMERIC(21, 2), tax3        NUMERIC(21, 2), tax4         NUMERIC(21, 2),
		tax5      NUMERIC(21, 2), tax6      NUMERIC(21, 2), factor_impu NUMERIC(21, 2), ccasa        INT,
		id_moau   INT,            ratio     NUMERIC(21, 2)
	)
	
	DECLARE @ImpIncl BIT = (SELECT TOP 1 impu_inc FROM RESTTABL)
	
	-- Cuenta Ingreso (Totalizado, Requiere enlace a Front o Conta)
	IF @Modo = 0 AND (@EnlaceFront = 1 OR @EnlaceAcc = 1)
	BEGIN
		
		IF @EnlaceFront = 1
		BEGIN
			
			INSERT INTO #Ventas
			SELECT  '',
			        hfac.id_mone,     hfac.id_pvta,   Pvta.cod_pvta, Pvta.desc_pvta,
			        hfad.id_fami,     hfad.desc_fami, 
			        0, '', '',
			        hfac.cod_mone, hfac.desc_mone, 
			        0,
			        enfa.id_cta_con1, 
			        conc_ingreso = con1.desc_con1,
			        tasa_inv     = dbo.lnk_Get_Tasa_Mone_Inv(hfac.id_mone), 
			        vbrutas      = ABS(ROUND( Sum( dbo.Get_Importe_Bruto_Hist_Contable(hfad.id_fali) * hfad.cantidad), 2)), 
			        vnetas       = ABS(ROUND( Sum( hfal.importe_neto_cont * hfad.cantidad ), 2)), 
			        dcto         = ABS(ROUND( SUM( hfal.dcto_noccasa * hfad.cantidad ), 2)), 
			        recargo      = ABS(ROUND( SUM( hfal.recargo_noccasa * hfad.cantidad ), 2)), 
			        vcosto       = ABS(ROUND( Sum( hfad.precio_costo * hfad.cantidad), 2)),	
			        impu_vent    = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,1) * hfad.cantidad ),2)),
			        impu_serv    = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,2) * hfad.cantidad ),2)),
			        tax3         = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,3) * hfad.cantidad ),2)),
			        tax4         = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,4) * hfad.cantidad ),2)),
			        tax5         = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,5) * hfad.cantidad ),2)),
			        tax6         = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,6) * hfad.cantidad ),2)),
			        factor_impu  = ROUND(1 + (dbo.Calc_Impu_Enfa_Tot_NoExentos(hfad.id_enfa,hfac.id_exen) / 100), 2),
			        ccasa        = 0, 
			        hfac.id_moau,
			        0	
			From VRESTHFAD hfad 
			INNER JOIN RESTHFAL  hfal on hfad.id_fali = hfal.id_fali 
			INNER JOIN VRESTHFAC hfac ON hfal.id_fact = hfac.id_fact 
			INNER JOIN RestPvta  Pvta ON HFac.id_pvta = pvta.id_pvta 
			INNER JOIN RESTENFA  enfa on hfad.id_enfa = enfa.id_enfa 
			INNER JOIN HOTECON1  con1 on enfa.id_cta_con1 = con1.id_con1 
			INNER JOIN RestTurn  Turn ON hfac.id_turn = turn.id_turn 
			Where hfac.estado = 4 and 
			      dbo.Es_CtaCasa_Hist(hfac.id_fact)  = 0  
			  and Datediff(day,@FecIni ,turn.fecha_ini) >=0  
			  and DateDiff(day,@FecFin ,turn.fecha_ini) <=0  
		    Group by hfad.id_fami,   hfac.id_pvta, 
		             pvta.cod_pvta,  pvta.desc_pvta, 
		             hfad.desc_fami, hfac.id_moau,
		             cod_mone,
		             enfa.id_cta_con1, 
		             con1.desc_con1, 
		             hfac.id_mone, hfac.desc_mone, hfad.id_enfa,
		             hfac.id_exen 
		    Order by hfac.id_mone, 
		             Pvta.cod_pvta, con1.desc_con1, 
		             desc_fami
			
		END
		
	END
	
	-- Por Familias (Resumido)
	IF @Modo = 1 
	BEGIN
		
		INSERT INTO #Ventas
		SELECT  '',
		        hfac.id_mone, hfac.id_pvta,   Pvta.cod_pvta, Pvta.desc_pvta,
		        hfad.id_fami, hfad.desc_fami,
		        0, '', '',
		        hfac.cod_mone, hfac.desc_mone, 
		        0, 
		        0, '',
		        tasa_inv    = dbo.lnk_Get_Tasa_Mone_Inv(hfac.id_mone), 
		        vbrutas     = ABS(ROUND( Sum( dbo.Get_Importe_Bruto_Hist_Contable(hfad.id_fali) * hfad.cantidad ), 2)), 
		        vnetas      = ABS(ROUND( Sum( hfal.importe_neto_cont * hfad.cantidad ), 2)), 
		        dcto        = ABS(ROUND( SUM( hfal.dcto_noccasa * hfad.cantidad ), 2)), 
		        recargo     = ABS(ROUND( SUM( hfal.recargo_noccasa * hfad.cantidad ), 2)), 
		        vcosto      = ABS(ROUND( Sum( hfad.precio_costo * hfad.cantidad), 2)),	
		        impu_vent   = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,1) * hfad.cantidad ),2)),
		        impu_serv   = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,2) * hfad.cantidad ),2)),
		        tax3        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,3) * hfad.cantidad ),2)),
		        tax4        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,4) * hfad.cantidad ),2)),
		        tax5        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,5) * hfad.cantidad ),2)),
		        tax6        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,6) * hfad.cantidad ),2)),
		        factor_impu = ROUND(1 + (dbo.Calc_Impu_Enfa_Tot_NoExentos(hfad.id_enfa,hfac.id_exen) / 100), 2),
		        ccasa       = 0 , 
		        hfac.id_moau,
		        0	
		From       VRESTHFAD hfad 
		INNER JOIN RESTHFAL  hfal  on hfad.id_fali = hfal.id_fali 
		INNER JOIN VRESTHFAC hfac ON hfal.id_fact = hfac.id_fact 
		INNER JOIN RestPvta Pvta ON HFac.id_pvta = pvta.id_pvta 
		INNER JOIN RestTurn Turn ON hfac.id_turn = turn.id_turn 
		Where hfac.estado = 4 
		  and dbo.Es_CtaCasa_Hist(hfac.id_fact)  = 0  
		  and Datediff(day,@FecIni ,turn.fecha_ini) >=0  
		  and DateDiff(day,@FecFin ,turn.fecha_ini) <=0  
	    Group by hfad.id_fami,   hfac.id_pvta, 
	             pvta.cod_pvta, pvta.desc_pvta, 
	             hfad.desc_fami, hfac.id_moau, 
	             cod_mone,      hfac.id_mone, 
	             hfac.desc_mone, hfad.id_enfa, hfac.id_exen 
	    Order by hfac.id_mone, Pvta.cod_pvta, desc_fami
		
	END
	
	-- Artculo (Detallado)
	IF @Modo = 2
	BEGIN
	
		IF @MasVendidos = 1
		BEGIN
		
		    INSERT INTO #Ventas
			SELECT '',
			       hfac.id_mone, hfac.id_pvta,  Pvta.cod_pvta,  Pvta.desc_pvta,
			       hfad.id_fami, '',
			       hfad.id_arti, hfad.cod_arti, hfad.desc_arti, 
			       hfac.cod_mone, hfac.desc_mone, 
			       cantidad    = Sum(ISNULL(hfad.cantidad, 0)),
			       0, '', 
			       tasa_inv    = dbo.lnk_Get_Tasa_Mone_Inv(hfac.id_mone),
			       vbrutas     = ABS(ROUND( Sum( dbo.Get_Importe_Bruto_Hist_Contable(hfad.id_fali) * hfad.cantidad ), 2)), 
			       vnetas      = ABS(ROUND( Sum( hfal.importe_neto_cont * hfad.cantidad ), 2)), 
			       dcto        = ABS(ROUND( SUM( hfal.dcto_noccasa * hfad.cantidad ), 2)), 
			       recargo     = ABS(ROUND( SUM( hfal.recargo_noccasa * hfad.cantidad ), 2)), 
			       vcosto      = ABS(ROUND( Sum( hfad.precio_costo * hfad.cantidad), 2)),	
			       impu_vent   = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,1) * hfad.cantidad ),2)),
			       impu_serv   = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,2) * hfad.cantidad ),2)),
			       tax3        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,3) * hfad.cantidad ),2)),
			       tax4        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,4) * hfad.cantidad ),2)),
			       tax5        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,5) * hfad.cantidad ),2)),
			       tax6        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,6) * hfad.cantidad ),2)),
			       factor_impu = 0 /*ROUND(1 + (dbo.Calc_Impu_Enfa_Tot_NoExentos(hfad.id_enfa,hfac.id_exen) / 100), 2)*/,
			       ccasa       = 0, 
			       hfac.id_moau,
			       0	
			 From       VRESTHFAD hfad 
			 INNER JOIN RESTHFAL  hfal on hfad.id_fali = hfal.id_fali 
			 INNER JOIN VRESTHFAC hfac ON hfal.id_fact = hfac.id_fact 
			 INNER JOIN RestPvta  Pvta ON HFac.id_pvta = pvta.id_pvta 
			 INNER JOIN RestTurn  Turn ON hfac.id_turn = turn.id_turn 
			 Where hfac.estado = 4  
			   and dbo.Es_CtaCasa_Hist(hfac.id_fact) = 0  
			   and Datediff(day,@FecIni ,turn.fecha_ini) >=0  
			   and DateDiff(day,@FecFin ,turn.fecha_ini) <=0  
			 Group by hfad.id_arti,  hfac.id_pvta, 
			          pvta.cod_pvta, pvta.desc_pvta, 
			          hfad.cod_arti, hfad.desc_arti, 
			          hfac.id_moau,  hfac.cod_mone, 
			          hfac.id_mone,  hfac.desc_mone, hfad.id_enfa,  /*hfac.id_exen,*/
			          hfad.id_fami 
			 Order by hfac.id_mone, cantidad DESC, hfad.cod_arti, Pvta.cod_pvta
		
		END
		ELSE
		BEGIN
		    
		    INSERT INTO #Ventas
			SELECT '', 
			       hfac.id_mone, hfac.id_pvta,  Pvta.cod_pvta,  Pvta.desc_pvta,
			       ISNULL(hfad.id_fami, 0) AS id_fami, '', 
			       arti.id_arti, arti.cod_arti, arti.desc_arti, 
			       hfac.cod_mone, hfac.desc_mone, 
			       cantidad    = Sum(ISNULL(hfad.cantidad, 0)),
			       0, '', 
			       tasa_inv    = dbo.lnk_Get_Tasa_Mone_Inv(hfac.id_mone), 
			       vbrutas     = ABS(ROUND( Sum( dbo.Get_Importe_Bruto_Hist_Contable(hfad.id_fali) * hfad.cantidad ), 2)), 
			       vnetas      = ABS(ROUND( Sum( hfal.importe_neto_cont * hfad.cantidad ), 2)), 
			       dcto        = ABS(ROUND( SUM( hfal.dcto_noccasa * hfad.cantidad ), 2)), 
			       recargo     = ABS(ROUND( SUM( hfal.recargo_noccasa * hfad.cantidad ), 2)), 
			       vcosto      = ABS(ROUND( Sum( hfad.precio_costo * hfad.cantidad), 2)),	
			       impu_vent   = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,1) * hfad.cantidad ),2)),
			       impu_serv   = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,2) * hfad.cantidad ),2)),
			       tax3        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,3) * hfad.cantidad ),2)),
			       tax4        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,4) * hfad.cantidad ),2)),
			       tax5        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,5) * hfad.cantidad ),2)),
			       tax6        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,6) * hfad.cantidad ),2)),
			       factor_impu = 0 /*ROUND(1 + (dbo.Calc_Impu_Enfa_Tot_NoExentos(hfad.id_enfa,hfac.id_exen) / 100), 2)*/,
			       ccasa       = 0, 
			       hfac.id_moau,
			       0
			 From      RESTARTI  arti 
			 LEFT JOIN VRESTHFAD hfad on arti.id_arti = hfad.id_arti 
			 LEFT JOIN RESTHFAL  hfal on hfad.id_fali = hfal.id_fali 
			 LEFT JOIN VRESTHFAC hfac ON hfal.id_fact = hfac.id_fact 
			 LEFT JOIN RestPvta  Pvta ON HFac.id_pvta = pvta.id_pvta 
			 LEFT JOIN RestTurn  Turn ON hfac.id_turn = turn.id_turn 
			 Where (hfac.id_fact is null or hfac.estado = 4) 
			   and  arti.id_arti 
			   not in (Select id_aral_arti 
			              From restescd 
			              where sub_esc = 1)  
               and arti.eliminado = 0  
               and dbo.Es_CtaCasa_Hist(hfac.id_fact) = 0  
               and (   Turn.id_turn is null 
                    or (Datediff(day,@FecIni ,turn.fecha_ini) >=0  
               and DateDiff(day,@FecFin ,turn.fecha_ini) <=0) )  
			 Group by arti.id_arti,  hfac.id_pvta,  
			          pvta.cod_pvta, pvta.desc_pvta, 
			          arti.cod_arti, arti.desc_arti, 
			          hfac.id_moau,  hfac.cod_mone, 
			          hfac.id_mone,  hfac.desc_mone, hfad.id_enfa,  /*hfac.id_exen,*/
			          hfad.id_fami 
			 Order by hfac.id_mone, cantidad ASC, arti.cod_arti, Pvta.cod_pvta
			 
		END
	
	END
	
	-- Cuenta Casa
	IF @Modo = 3
	BEGIN
	 
	    --INSERT INTO #Ventas
		--SELECT  dbo.Get_Refer_Cobro(TCob.id_fpag, hfco.id_line_cline, hfco.id_dato) AS Credito,
		--        0,
		--        hfac.id_pvta, Pvta.cod_pvta, Pvta.desc_pvta,
		--        hfad.id_fami, hfad.desc_fami,
		--        0, '', '', 
		--        '', '',
		--        0,
		--        0, '', 
		--        tasa_inv    = dbo.lnk_Get_Tasa_Mone_Inv(hfac.id_mone), 
		--        vbrutas     = ABS(ROUND( Sum( dbo.Get_Importe_Bruto_Hist_Contable(hfad.id_fali) * hfad.cantidad), 2)), 
		--        vnetas      = ABS(ROUND( Sum( hfal.importe_neto_cont * hfad.cantidad ), 2)), 
		--        dcto        = ABS(ROUND( SUM( hfal.dcto_neto    * hfad.cantidad ), 2)), 
		--        recargo     = ABS(ROUND( SUM( hfal.recargo_neto * hfad.cantidad ), 2)), 
		--        vcosto      = ABS(ROUND( Sum( hfad.precio_costo * hfad.cantidad ), 2)),	
		--        impu_vent   = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,1) * hfad.cantidad ),2)),
		--        impu_serv   = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,2) * hfad.cantidad ),2)),
		--        tax3        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,3) * hfad.cantidad ),2)),
		--        tax4        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,4) * hfad.cantidad ),2)),
		--        tax5        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,5) * hfad.cantidad ),2)),
		--        tax6        = ABS(ROUND( SUM( dbo.Get_Suma_Impu_Grupo_Hist(hfad.id_fali,6) * hfad.cantidad ),2)),
		--        factor_impu = ROUND(1 + (dbo.Calc_Impu_Enfa_Tot_NoExentos(hfad.id_enfa,hfac.id_exen) / 100), 2),
		--        ccasa       = ABS(ROUND( Sum( hfal.importe_neto_cont * hfad.cantidad ), 2)),
		--        0,
		--        0 
		--FROM       RESTHFCO  hfco 
		--INNER JOIN RestTcob  Tcob ON hfco.id_tcob = tcob.id_tcob 
		--INNER JOIN RESTHFAL  hfal ON hfco.id_fact = hfal.id_fact 
		--INNER JOIN VRESTHFAD hfad ON hfal.id_fali = hfad.id_fali 
		--INNER JOIN VRESTHFAC hfac ON hfal.id_fact = hfac.id_fact 
		--INNER JOIN RestPvta  Pvta ON HFac.id_pvta = pvta.id_pvta 
		--INNER JOIN RestTurn  Turn ON hfac.id_turn = turn.id_turn , RestTabl Tabl 
		--WHERE hfac.Estado = 4 and 
		--      dbo.Es_CtaCasa_Hist(hfac.id_fact)  = 1 and 
		--      Tcob.id_fpag = 5 and 
		--      tcob.cuenta_casa = 1  and 
		--      --hfac.id_pvta = 2 and 
		--      --hfad.id_fami = 60 and 
		--      ( Turn.id_turn is null or (Datediff(day,@FecIni ,turn.fecha_ini) >=0  and 
		--                                 DateDiff(day,@FecFin ,turn.fecha_ini) <=0) )  
		--Group by dbo.Get_Refer_Cobro(TCob.id_fpag, hfco.id_line_cline, hfco.id_dato), 
		--         hfad.id_fami, hfac.id_pvta,   pvta.cod_pvta, pvta.desc_pvta,
		--         hfac.id_mone, hfad.desc_fami, hfad.id_enfa,  hfac.id_exen 
		--Order by credito, Pvta.cod_pvta, hfad.desc_fami
		
		INSERT INTO #Ventas
		SELECT  v.Credito,
		        v.id_mone,   v.id_pvta,  v.cod_pvta,    v.desc_pvta,
		        CONVERT(INT, ISNULL(v.id_fami, 0)),     v.desc_fami,
		        v.id_arti,   v.cod_arti, v.desc_arti,   v.cod_mone,
		        v.desc_mone, v.cantidad, v.id_cta_con1, v.conc_ingres,
		        v.tasa_inv,  v.vbrutas,
		        v.vnetas,    CONVERT(NUMERIC(21, 2), 
		        ISNULL(v.dcto_neto, 0)), CONVERT(NUMERIC(21, 2), 
		        ISNULL(v.recargo_neto, 0)), ISNULL(v.precio_costo, 0), 
		        0, 0, 0, 0,
		        0, 0, 0, 0,
		        0, 0
		FROM   VArticulosCC v
		--WHERE   v.fecha_factura BETWEEN @FecIni AND @FecFin
		WHERE v.estado = 4 and 
		      dbo.Es_CtaCasa_Hist(v.id_fact)  = 1 and 
		      v.id_fpag = 5 and 
		      --v.cuenta_casa = 1  and 
		      --v.id_pvta = 2 and 
		      --v.id_fami = 60 and 
		      ( v.id_turn is null or (Datediff(day,@FecIni ,v.fecha_ini) >=0  and 
		                              DateDiff(day,@FecFin ,v.fecha_ini) <=0) )  
	
	END
	
	IF @id_pvta > 0
	BEGIN
		DELETE FROM #Ventas WHERE id_pvta <> @id_pvta
	END
	
	IF @id_fami > 0
	BEGIN
		DELETE FROM #Ventas WHERE id_fami <> @id_fami
	END
	
	SELECT *,
	       CASE @Modo
	            WHEN 0 THEN 'Punto de Venta'
	            WHEN 1 THEN 'Punto de Venta'
	            WHEN 2 THEN ''
	            WHEN 3 THEN 'Descripcin del Consumo'
	            ELSE 'ERROR'
	            END AS Agrupador, 
	       CASE @Modo
	            WHEN 0 THEN LTRIM(RTRIM(v.desc_pvta))
	            WHEN 1 THEN LTRIM(RTRIM(v.desc_pvta))
	            WHEN 2 THEN ''
	            WHEN 3 THEN LTRIM(RTRIM(v.Credito))
	            ELSE 'ERROR'
	            END AS AgrupadorVal,
	       CASE @Modo
	            WHEN 0 THEN 'Concepto de Ingreso'
	            WHEN 1 THEN 'Familia'
	            WHEN 2 THEN 'Artculo'
	            WHEN 3 THEN 'Punto de Venta'
	            ELSE 'ERROR'
	            END AS Detalle, 
	       CASE @Modo
	            WHEN 0 THEN LTRIM(RTRIM(v.conc_ingreso))
	            WHEN 1 THEN LTRIM(RTRIM(v.desc_fami))
	            WHEN 2 THEN LTRIM(RTRIM(v.cod_arti + ' - ' + v.desc_arti))
	            WHEN 3 THEN LTRIM(RTRIM(v.desc_pvta))
	            ELSE 'ERROR'
	            END AS DetalleVal,
	       CASE @Modo
	            WHEN 0 THEN 1
	            WHEN 1 THEN 1
	            WHEN 2 THEN 0
	            WHEN 3 THEN 1
	            ELSE 1
	            END AS Agrupa,
	       CASE @Modo
	            WHEN 0 THEN 1
	            WHEN 1 THEN 1
	            WHEN 2 THEN 0
	            WHEN 3 THEN 0
	            ELSE 1
	            END AS TieneNotas,
	       CASE @Modo
	            WHEN 0 THEN 0
	            WHEN 1 THEN 0
	            WHEN 2 THEN 1
	            WHEN 3 THEN 1
	            ELSE 1
	            END AS TieneCantidad,
	       CASE @Modo
	            WHEN 0 THEN 0
	            WHEN 1 THEN 0
	            WHEN 2 THEN 1
	            WHEN 3 THEN 1
	            ELSE 1
	            END AS TieneRatios
	       ,
	       @vPOS         AS POS,
	       @vFamilia     AS Familia,
	       @vCantArti    AS CantArticulos,
	       @vMasVendidos AS MasVendidos,
	       @FecIni       AS FecIni,
	       @FecFin       AS FecFin
	INTO #Ventas2
    FROM #Ventas v
    
    IF @Modo = 2
    BEGIN
		
		SELECT escd.*, 
		       CASE escd.sub_esc 
		            WHEN 0 THEN aral.Cod_Aral 
                    ELSE arti.Cod_Arti 
                    END AS Codigo, 
               CASE escd.sub_esc 
                    WHEN 0 THEN aral.Desc_Aral 
                    ELSE arti.Desc_Arti 
                    END AS Descripcion, 
               CASE escd.sub_esc 
                    WHEN 0 THEN unme.Cod_Unme 
                    ELSE '''' 
                    END AS UMed, 
               CASE escd.sub_esc 
                    WHEN 0 THEN 
				         CASE WHEN Coalesce(Max(psec.p_costo), 0) = 0 THEN COALESCE(aral.p_costo, 0) 
				              ELSE Coalesce(Max(psec.p_costo), 0) 
				              END  
			        ELSE Coalesce(arti.Precio_Costo / arti.factor_div, 0) 
			        ENd As PCosto,
			   ISNULL(aral.existencia, 0) AS existencia 
		INTO #FichaTecnica
		FROM      RESTESCD escd 
		LEFT JOIN ALMAAREX aral ON escd.id_aral_arti = aral.id_aral and sub_esc = 0 
		LEFT JOIN ALMAUNME unme ON aral.id_unme      = unme.id_unme 
		LEFT JOIN ALMAPSEC psec ON aral.id_aral      = psec.id_aral 
		LEFT JOIN RESTARTI arti ON escd.id_aral_arti = arti.id_arti and sub_esc = 1 
		GROUP BY escd.id_escd,   escd.id_arti,  escd.id_aral_arti, escd.cantidad,  escd.sub_esc, 
		         escd.no_rebaja, aral.cod_aral, arti.cod_arti,     aral.desc_aral, arti.desc_arti, 
		         unme.cod_unme,  arti.Precio_Costo, arti.factor_div, aral.p_costo, aral.existencia 
		ORDER BY codigo, sub_esc
        
        IF @CantArti > 0
		BEGIN
			IF @MasVendidos = 1
			BEGIN
			
				SET @vSql = 'SELECT TOP ' + CONVERT(VARCHAR(50), @CantArti) + ' * INTO #Ventas3 FROM #Ventas2
				
							 SELECT v.*,
								    f.Codigo      AS IngCodigo,
								    f.Descripcion AS IngDescripcion,
								    f.UMed        AS IngUnidadMedida,   
								    f.cantidad    AS IngCantidad,
								    f.PCosto      AS IngPrecio,
								    f.existencia  AS IngExistencia,
								    f.sub_esc     AS IngArtPV,
								    ISNULL(p.precio_base, 0) AS ArtPrecioVenta 
						     INTO            #Ventas4
							 FROM            #Ventas3      v
							 LEFT OUTER JOIN RESTESCD      r ON v.id_arti = r.id_arti
							 LEFT OUTER JOIN RESTPRBA      p ON v.id_arti = p.id_arti AND p.id_mone = v.id_mone
							 LEFT OUTER JOIN #FichaTecnica f ON r.id_escd = f.id_escd
							 
							 DECLARE @ImpInclC BIT = (SELECT TOP 1 impu_inc FROM RESTTABL)
							 
							 SELECT v.Credito,
								    v.id_mone   , v.id_pvta   , v.cod_pvta    , v.desc_pvta, 
								    v.id_fami   , v.desc_fami ,
								    v.id_arti   , v.cod_arti  , v.desc_arti   , v.cod_mone,
								    v.desc_mone , 
								    v.cantidad   / (CASE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
															  WHEN 0 THEN 1
															  ELSE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
															  END)  AS cantidad, 
								    v.id_cta_con1 , v.conc_ingreso, v.tasa_inv  , 
								    v.vbrutas    / (CASE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
									 						  WHEN 0 THEN 1
									 						  ELSE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
									 						  END)  AS vbrutas ,
								    v.vnetas     / (CASE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
															  WHEN 0 THEN 1
															  ELSE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
															  END)  AS vnetas  , 
								    v.dcto       / (CASE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
															  WHEN 0 THEN 1
															  ELSE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
															  END)  AS dcto, 
								    v.recargo    / (CASE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
															  WHEN 0 THEN 1
															  ELSE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
															  END)  AS recargo , 
								    v.vcosto     / (CASE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
															  WHEN 0 THEN 1
															  ELSE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
															  END)  AS vcosto ,
								    v.impu_vent  / (CASE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
															  WHEN 0 THEN 1
															  ELSE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
															  END)  AS impu_vent, 
								    v.impu_serv  / (CASE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
															  WHEN 0 THEN 1
															  ELSE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
															  END)  AS impu_serv, 
								    v.tax3        , v.tax4         ,
								    v.tax5      , v.tax6      , v.factor_impu , v.ccasa        ,
								    v.id_moau   , v.ratio     ,
								    v.Agrupador, 
								    v.AgrupadorVal,
								    v.Detalle, 
								    v.DetalleVal,
								    v.Agrupa,
								    v.TieneNotas,
								    v.TieneCantidad,
								    v.TieneRatios,
								    v.POS,
								    v.Familia,
								    v.CantArticulos,
								    v.MasVendidos,
								    v.FecIni,
								    v.FecFin,
								    v.IngCodigo,
								    v.IngDescripcion,
								    CASE v.IngArtPV
								         WHEN 1 THEN ''Art. PV''
								         ELSE v.IngUnidadMedida
								         END AS IngUnidadMedida,   
								    v.IngCantidad,
								    v.IngPrecio,
								    v.IngExistencia,
								    v.ArtPrecioVenta,
								    @ImpInclC AS ArtPVImpIncl 
							 FROM   #Ventas4      v
							 ORDER BY v.cantidad  / (CASE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
															  WHEN 0 THEN 1
															  ELSE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
															  END)  DESC
							 
							 '
							 
				EXEC(@vSQL)
				
				
				
			END
			ELSE
			BEGIN
			
				SET @vSql = 'SELECT TOP ' + CONVERT(VARCHAR(50), @CantArti) + ' * INTO #Ventas3 FROM #Ventas2 ORDER BY ISNULL(#Ventas2.cantidad, 0) ASC
				
							 SELECT v.*,
								    f.Codigo      AS IngCodigo,
								    f.Descripcion AS IngDescripcion,
								    f.UMed        AS IngUnidadMedida,   
								    f.cantidad    AS IngCantidad,
								    f.PCosto      AS IngPrecio,
								    f.existencia  AS IngExistencia,
								    f.sub_esc     AS IngArtPV,
								    ISNULL(p.precio_base, 0) AS ArtPrecioVenta   
						     INTO            #Ventas4
							 FROM            #Ventas3      v
							 LEFT OUTER JOIN RESTESCD      r ON v.id_arti = r.id_arti
							 LEFT OUTER JOIN RESTPRBA      p ON v.id_arti = p.id_arti AND p.id_mone = v.id_mone
							 LEFT OUTER JOIN #FichaTecnica f ON r.id_escd = f.id_escd
							 
							 DECLARE @ImpInclC BIT = (SELECT TOP 1 impu_inc FROM RESTTABL)
							 
							 SELECT v.Credito,
								    v.id_mone   , v.id_pvta   , v.cod_pvta    , v.desc_pvta, 
								    v.id_fami   , v.desc_fami ,
								    v.id_arti   , v.cod_arti  , v.desc_arti   , v.cod_mone,
								    v.desc_mone , 
								    v.cantidad   / (CASE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
															  WHEN 0 THEN 1
															  ELSE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
															  END)  AS cantidad, 
								    v.id_cta_con1 , v.conc_ingreso, v.tasa_inv  , 
								    v.vbrutas    / (CASE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
									 						  WHEN 0 THEN 1
									 						  ELSE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
									 						  END)  AS vbrutas ,
								    v.vnetas     / (CASE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
															  WHEN 0 THEN 1
															  ELSE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
															  END)  AS vnetas  , 
								    v.dcto       / (CASE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
															  WHEN 0 THEN 1
															  ELSE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
															  END)  AS dcto, 
								    v.recargo    / (CASE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
															  WHEN 0 THEN 1
															  ELSE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
															  END)  AS recargo , 
								    v.vcosto     / (CASE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
															  WHEN 0 THEN 1
															  ELSE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
															  END)  AS vcosto ,
								    v.impu_vent  / (CASE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
															  WHEN 0 THEN 1
															  ELSE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
															  END)  AS impu_vent, 
								    v.impu_serv  / (CASE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
															  WHEN 0 THEN 1
															  ELSE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
															  END)  AS impu_serv, 
								    v.tax3        , v.tax4         ,
								    v.tax5      , v.tax6      , v.factor_impu , v.ccasa        ,
								    v.id_moau   , v.ratio     ,
								    v.Agrupador, 
								    v.AgrupadorVal,
								    v.Detalle, 
								    v.DetalleVal,
								    v.Agrupa,
								    v.TieneNotas,
								    v.TieneCantidad,
								    v.TieneRatios,
								    v.POS,
								    v.Familia,
								    v.CantArticulos,
								    v.MasVendidos,
								    v.FecIni,
								    v.FecFin,
								    v.IngCodigo,
								    v.IngDescripcion,
								    CASE v.IngArtPV
								         WHEN 1 THEN ''Art. PV''
								         ELSE v.IngUnidadMedida
								         END AS IngUnidadMedida, 
								    v.IngCantidad,
								    v.IngPrecio,
								    v.IngExistencia,
								    v.ArtPrecioVenta,
								    @ImpInclC AS ArtPVImpIncl  
							 FROM   #Ventas4      v
							 ORDER BY v.cantidad  / (CASE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
															  WHEN 0 THEN 1
															  ELSE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
															  END)  ASC
							 '
							 
				EXEC(@vSQL)
				
			END
			
		END
		ELSE
		BEGIN
			
			SELECT v.*,
				   f.Codigo      AS IngCodigo,
				   f.Descripcion AS IngDescripcion,
				   f.UMed        AS IngUnidadMedida,   
				   f.cantidad    AS IngCantidad,
				   f.PCosto      AS IngPrecio,
				   f.existencia  AS IngExistencia,
				   f.sub_esc     AS IngArtPV,
				   ISNULL(p.precio_base, 0) AS ArtPrecioVenta     
		    INTO            #Ventas4
			FROM            #Ventas2      v
			LEFT OUTER JOIN RESTESCD      r ON v.id_arti = r.id_arti
			LEFT OUTER JOIN RESTPRBA      p ON v.id_arti = p.id_arti AND p.id_mone = v.id_mone
			LEFT OUTER JOIN #FichaTecnica f ON r.id_escd = f.id_escd
			
			SELECT v.Credito,
		           v.id_mone   , v.id_pvta   , v.cod_pvta    , v.desc_pvta, 
		           v.id_fami   , v.desc_fami ,
		           v.id_arti   , v.cod_arti  , v.desc_arti   , v.cod_mone,
				   v.desc_mone , 
				   v.cantidad   / (CASE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
			                                  WHEN 0 THEN 1
			                                  ELSE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
			                                  END)  AS cantidad, 
				   v.id_cta_con1 , v.conc_ingreso, v.tasa_inv  , 
				   v.vbrutas    / (CASE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
			                                  WHEN 0 THEN 1
			                                  ELSE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
			                                  END)  AS vbrutas ,
				   v.vnetas     / (CASE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
			                                  WHEN 0 THEN 1
			                                  ELSE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
			                                  END)  AS vnetas  , 
				   v.dcto       / (CASE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
			                                  WHEN 0 THEN 1
			                                  ELSE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
			                                  END)  AS dcto, 
			       v.recargo    / (CASE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
			                                  WHEN 0 THEN 1
			                                  ELSE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
			                                  END)  AS recargo , 
			       v.vcosto     / (CASE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
			                                  WHEN 0 THEN 1
			                                  ELSE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
			                                  END)  AS vcosto ,
				   v.impu_vent  / (CASE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
			                                  WHEN 0 THEN 1
			                                  ELSE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
			                                  END)  AS impu_vent, 
				   v.impu_serv  / (CASE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
			                                  WHEN 0 THEN 1
			                                  ELSE (SELECT COUNT(*) FROM #Ventas4 tg WHERE tg.id_arti = v.id_arti AND tg.id_pvta = v.id_pvta AND tg.id_mone = v.id_mone)
			                                  END) AS impu_serv, 
			       v.tax3        , v.tax4         ,
				   v.tax5      , v.tax6      , v.factor_impu , v.ccasa        ,
		           v.id_moau   , v.ratio     ,
		           v.Agrupador, 
				   v.AgrupadorVal,
				   v.Detalle, 
				   v.DetalleVal,
				   v.Agrupa,
				   v.TieneNotas,
				   v.TieneCantidad,
				   v.TieneRatios,
				   v.POS,
				   v.Familia,
				   v.CantArticulos,
				   v.MasVendidos,
				   v.FecIni,
				   v.FecFin,
			       v.IngCodigo,
			       v.IngDescripcion,
			       CASE v.IngArtPV
				        WHEN 1 THEN 'Art. PV'
				        ELSE v.IngUnidadMedida
				        END AS IngUnidadMedida,  
			       v.IngCantidad,
			       v.IngPrecio,
			       v.IngExistencia,
			       v.ArtPrecioVenta,
	               @ImpIncl AS ArtPVImpIncl   
			FROM   #Ventas4      v
			ORDER BY v.cantidad / (CASE (SELECT COUNT(*) 
			                                FROM #Ventas4 tg 
			                                WHERE tg.id_arti = v.id_arti 
			                                AND tg.id_mone = v.id_mone)
			                             WHEN 0 
			                             THEN 1
			                             ELSE 
			                                (SELECT COUNT(*) 
			                                    FROM #Ventas4 tg 
			                                    WHERE tg.id_arti = v.id_arti 
			                                      AND tg.id_mone = v.id_mone)
			                             END) DESC
			
		END
    
    END
    ELSE
	BEGIN
	
		IF @MasVendidos = 1
		BEGIN
        
			SELECT *,
				   NULL AS IngCodigo,
				   NULL AS IngDescripcion,
				   NULL AS IngUnidadMedida,   
				   NULL AS IngCantidad,
				   NULL AS IngPrecio,
				   NULL AS IngExistencia,
				   NULL AS ArtPrecioVenta,
				   @ImpIncl AS ArtPVImpIncl    
			FROM #Ventas2
			ORDER BY cantidad DESC
	    
	    END
	    ELSE
	    BEGIN
	    
			SELECT *,
				   NULL AS IngCodigo,
				   NULL AS IngDescripcion,
				   NULL AS IngUnidadMedida,   
				   NULL AS IngCantidad,
				   NULL AS IngPrecio,
				   NULL AS IngExistencia,
				   NULL AS ArtPrecioVenta,
				   @ImpIncl AS ArtPVImpIncl     
			FROM #Ventas2
			ORDER BY cantidad ASC
	    
	    END
		
	END
	
	RETURN

END
