
/****** Object:  StoredProcedure [dbo].[DSS_FRONT_Booking]    Script Date: 08/14/2013 13:04:18 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO


ALTER PROCEDURE [dbo].[DSS_FRONT_Booking]
                (@Modo   INT, -- 0: Ocupacin, 1: Disponibilidad
				@FecIni DATE,
				@FecFin DATE)
AS
BEGIN 

	-- Obtener total de habitaciones
	DECLARE @TotHabi FLOAT
	EXEC Calc_Habitaciones_Hotel @TotHabi OUTPUT
	
	CREATE TABLE #TipoHabi
				(id_thab    INT,
				 tipo_hab   CHAR(9),
				 desc_t_hab CHAR(25))
				 
	-- Usar el grupo de disponibilidad establecido como el primario
	
	DECLARE @id_disp INT = (SELECT TOP 1 id_disp FROM hotedisp WHERE activo = 1 ORDER BY orden_visual)
	
	INSERT INTO #TipoHabi
	EXEC Det_Tipos_Habit NULL, @id_disp
	
	CREATE TABLE #TempBooking
	(
		booking INT,
		ford    INT,
		ocup    INT,
		reserv  INT,
		salen   INT,
		total   INT
	)
	
	CREATE TABLE #Booking
	(
		Dia      DATE,
		TipoHabi INT,
		CodHabi  CHAR(9),
		Ocup     INT,
		Total    INT
	)
	
	DECLARE @Inicio  INT  = (SELECT MIN(id_thab) FROM #TipoHabi)
	DECLARE @Final   INT  = (SELECT MAX(id_thab) FROM #TipoHabi)
	DECLARE @InicioB INT  = 0
	DECLARE @FinalB  INT  = 0
	DECLARE @i       INT  = @Inicio
	DECLARE @j       INT  = 0
	DECLARE @FecAct  DATE = @FecIni
	DECLARE @HayReg  INT  = 0
	
	WHILE @i <= @Final
	BEGIN
	
		SELECT @HayReg = ISNULL(id_thab, 0) FROM #TipoHabi
		
		IF @HayReg <> 0
		BEGIN
		
			INSERT INTO #TempBooking
			EXEC Calc_Booking_Tipo @i, @FecIni, @FecFin, 0, 1, 1, 0, 1, 1, 1
			
			SELECT IDENTITY(INT, 1, 1) AS Id,
			       *
			INTO   #TempBooking2
			FROM   #TempBooking
			
			SELECT @InicioB = MIN(Id),
			       @FinalB  = MAX(Id)
			FROM   #TempBooking2
			
			SELECT @j = @InicioB
			
			WHILE @j <= @FinalB
			BEGIN 
			
				INSERT INTO #Booking
				(
					Dia,
					TipoHabi,
					CodHabi,
					Ocup,
					Total
				)
				VALUES
				(
					@FecAct,
					@i,
					(SELECT tipo_hab 
					    FROM #TipoHabi 
					    WHERE id_thab = @i),
					(SELECT (CASE @Modo 
					              WHEN 0 
					              THEN total - booking
					              ELSE booking
					              END) 
					    FROM #TempBooking2 WHERE Id = @j),
					@TotHabi)
				
				SET @FecAct = DATEADD(DAY, 1, @FecAct)
				SET @j = @j + 1
			
			END
			
			--SELECT * FROM #TempBooking
			--SELECT * FROM #TempBooking2
			
			DELETE     #TempBooking
			DROP TABLE #TempBooking2
			
			SET @FecAct = @FecIni
			SET @i = @i + 1
		
		END
		
	END
	
	SELECT *,
	       DATEDIFF(DAY, @FecIni, @FecFin) + 1 AS Dias,
	       @Modo AS Modo,
	       CASE @Modo 
			    WHEN 0 THEN 'Ocupadas'
			    WHEN 1 THEN 'Disponibles'
			    ELSE 'ERROR'
			    END AS Tipo
	FROM   #Booking
	
	RETURN

END
